package dynaaminen;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import fi.jyu.mit.ohj2.Tiedosto;

/**
 * Esimerkki Javan ArrayListin kytst Java 1.5:n geneerisyyden
 * ja "autoboxin" avulla.
 * @author Vesa Lappalainen @version 1.0, 02.03.2002 
 * @version 1.1, 01.03.2005
 * @author Santtu Viitanen @version 1.2, 22.07.2011
 */

public class ArrayListMalliGen {

    /**
     * @param os virta johon tulostetaan
     * @param luvut tulostettavat luvut
     */
    public static void tulosta(OutputStream os, Collection<Integer> luvut) {
        @SuppressWarnings("resource")
        PrintStream out = Tiedosto.getPrintStream(os);
        for (int luku : luvut) {
            out.print(luku + " ");
        }
        out.println();
    }

    /**
     * @param os virta johon tulostetaan
     * @param luvut tulostettavat luvut
     */
    public static void tulostaIter(OutputStream os, Collection<Integer> luvut) {
        @SuppressWarnings("resource")
        PrintStream out = Tiedosto.getPrintStream(os);
        for (Iterator<Integer> it = luvut.iterator(); it.hasNext(); ) {
            int luku = it.next();
            out.print(luku + " ");
        }
        out.println();
    }

    /**
     * Esimekki listasta
     * @param args ei kytss
     */
    public static void main(String[] args) {
        ArrayList<Integer> luvut = new ArrayList<Integer>(7);
        try {
            luvut.add(0);
            luvut.add(2);
            luvut.add(99);
        } catch (Exception e) {
            System.out.println("Virhe: " + e.getMessage());
        }
        System.out.println(luvut);
        luvut.set(1, 4);
        System.out.println(luvut);
        int luku = luvut.get(2);
        System.out.println("Paikassa 2 on " + luku);
        tulosta(System.out, luvut);
        try {
            luvut.set(21, 4);
        } catch (IndexOutOfBoundsException e) {
            System.out.println("Virhe: " + e.getMessage());
        }
    }
}
