package muuttujat.testaus;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

/**
 * Ohjelmalla testataan onko_alkuluku-aliohjelmaa.  Testi tehdn
 * 3:lla eri tavalla
 *  - ComTest
 *  - JUnit
 *  - omatekoinen testiohjelma
 * @author Vesa Lappalainen @version 20.1.2011
 * @author Santtu Viitanen @version 12.8.2011
 *
 */
public class Alkuluku {

    /**
     * Aliohjelmalla tutkitaan onko parametrina tuotu
     * luku alkuluku vai ei<br>
     * Algoritmi: Jaetaan tutkittavaa lukua jakajilla 2,3,5,7...luku/2.
     * Jos jokin jako menee tasan, niin ei alkuluku:
     * 
     * @param luku tutkittava luku
     * @return luvun jolla jaollinen tai 1 jos alkuluku
     * @example
     * <pre name="test">
     *   onkoAlkuluku(25)  === 5;
     *   onkoAlkuluku(2)   === 1;
     *   onkoAlkuluku(4)   === 2;
     *   onkoAlkuluku(123) === 3;
     *   onkoAlkuluku(7)   === 1;
     * </pre>
     */
    public static int onkoAlkuluku(int luku) {
        int jakaja = 2;
        int kasvatus = 1;
        if ( luku == 2 ) return 1;                  // 0

        do {
            int jakojaannos = luku % jakaja;
            if (jakojaannos == 0) return jakaja; // 1
            jakaja += kasvatus; // 2
            kasvatus = 2; // 3

        } while (jakaja < luku / 2);        
        
        return 1;
    }
    
    /**
     * Testaan JUnitilla alkulukua
     */
    @Test
    public void testOnkoAlkuluku19() {
      assertEquals(5, onkoAlkuluku(25)); 
      assertEquals(1, onkoAlkuluku(2)); 
      assertEquals(2, onkoAlkuluku(4)); 
      assertEquals(3, onkoAlkuluku(123)); 
      assertEquals(1, onkoAlkuluku(7)); 
    } 
    
    /**
     * Testipohjelma onkoAlkuluku aliohjelman testaukseen
     * @param luku tutkittava luku
     * @param pieninJakaja true = alkuluku, false != alkuluku
     * @return 0 jos testi menee lpi, 1 muuten
     */
    public static int testiOnkoAlkuluku(int luku, int pieninJakaja) {
        if (pieninJakaja != onkoAlkuluku(luku))  {
            System.out.println("Luvun "+luku+" pienin jakaja on "+pieninJakaja+" mutta oli "+onkoAlkuluku(luku));
            return 1;
        }
        return 0;
    }
    
    /**
     * @param args ei kytet
     */
    public static void main(String[] args) {
        
        testiOnkoAlkuluku(25, 5);
        testiOnkoAlkuluku(2, 1);
        testiOnkoAlkuluku(4, 2);
        testiOnkoAlkuluku(123, 3);
        testiOnkoAlkuluku(7, 1);
        
    }
}
