package muuttujat.testaus;

import static org.junit.Assert.*;
import org.junit.Test;

/**
 * Ohjelma testauksen esittely varten
 * @author Santtu Viitanen
 * @version 1.0, 4.7.2011
 */
public class Esiintymat {

    /**
     * @param args ei kytss
     */
    public static void main(String[] args) {
        int[] t1 = { 1, 1, 3 };
        int[] t2 = { 1, 2 };
        int[] t3 = { 1, 3, 3, 4 };
        int[] t4 = {};
        enitenEsiintymiaTesti(t1, t2, 0);
        enitenEsiintymiaTesti(t1, t3, 2);
        enitenEsiintymiaTesti(t1, t4, 0);
        enitenEsiintymiaTesti(t4, t1, -1);
        enitenEsiintymiaTesti(t4, t4, -1);

    }


    /**
     * Testataan enitenEsiintymia-aliohjelmaa
     * @see #enitenEsiintymia(int[], int[])
     * @param i oletettu tulos
     */
    private static int enitenEsiintymiaTesti(int[] t1, int[] t2, int odotettu) {
        int tulos = enitenEsiintymia(t1, t2);
        if (tulos == odotettu) return 0;
        System.out.println("Tulokseksi tuli: " + tulos + " vaikka piti tulla: "
                + odotettu);
        return 1;
    }


    /**
     * 
     */
    @Test
    public void testEnitenEsiintymia() {
        int[] t1 = { 1, 1, 3 };
        int[] t2 = { 1, 2 };
        int[] t3 = { 1, 3, 3, 4 };
        int[] t4 = {};
        assertEquals(
                "Thn on mahdollista upottaa mys testausta helpottava viesti",
                0, enitenEsiintymia(t1, t2));
        assertEquals(2, enitenEsiintymia(t1, t3));
        assertEquals(0, enitenEsiintymia(t1, t4));
        assertEquals(-1, enitenEsiintymia(t4, t3));
        assertEquals(-1, enitenEsiintymia(t4, t4));
    }


    /**
     * Palauttaa indeksin t1 taulun arvoon, jolla on eniten esiintymi t2
     * taulussa. Mikli kahdella luvulla on saman verran esiintymi palautetaan
     * jonossa ensimminen arvo. Jos t1 on tyhj palautetaan -1
     * 
     * @param t1 taulukko, jonka indeksi palautetaan
     * @param t2 taulukko, johon verrataan
     * @return indeksi t1 taulun arvoon.
     * @example
     * <pre name="test">
     * int[] t1 = {1,1,3};
     * int[] t2 = {1,2};
     * int[] t3 = {1,3,3,4};
     * int[] t4 = {};
     * enitenEsiintymia(t1,t2) === 0;
     * enitenEsiintymia(t1,t3) === 2;
     * enitenEsiintymia(t1,t4) === 0;
     * enitenEsiintymia(t4,t1) === -1;
     * enitenEsiintymia(t4,t4) === -1;
     * 
     * //Testi vaihtoehtoisesti taulukkomuodossa
     * enitenEsiintymia($param1,$param2) === $tulos
     *  $param1 | $param2 | $tulos
     *  -----------------------
     *   t1     | t2     | 0   
     *   t1     | t3     | 2 
     *   t1     | t4     | 0 
     *   t4     | t1     | -1 
     *   t4     | t4     | -1 
     * </pre>

     * 
     * 
     */
    public static int enitenEsiintymia(int[] t1, int[] t2) {

        int paras = -1; // eniten esiintymi omaavan luvun indeksi
        int parhaanEsiintymat = -1; // esiintymien mrt

        /*
         * verrataan siskkisill for-silmukoilla taulujen arvoja toisiinsa
         */
        for (int i = 0; i < t1.length; i++) {
            int ehdokkaanEsiintymat = 0;

            for (int j = 0; j < t2.length; j++)
                if (t1[i] == t2[j]) ehdokkaanEsiintymat++;

            if (ehdokkaanEsiintymat > parhaanEsiintymat) {
                paras = i;
                parhaanEsiintymat = ehdokkaanEsiintymat;
            }
        }
        return paras;
    }
}
