package ohjausrak.vali;

/**
 * Ohjelmalla lasketaan vlin summa
 * @author Vesa Lappalainen @version 1.0, 16.02.2003
 * @author Santtu Viitanen @version 1.1, 03.08.2011
 */
public class Valinsum {

    /**
     * Lasketaan yhteen luvut 1..ylaraja
     * @param ylaraja summan ylraja
     * @return summa
     * @example
     * <pre name="test">
     * valinSumma($param1) === $tulos
     * $param1 | $tulos
     * -----------------
     *   0     |  0   
     *   1     |  1
     *   2     |  3
     *   3     |  6
     * </pre>
     */
    public static int valinSumma(int ylaraja) {
        int i, summa = 0;
        for (i = 1; i <= ylaraja; i++)
            summa += i;
        return summa;
    }


    /**
     * Lasketaan yhteen luvut 1..ylaraja
     * @param ylaraja summan ylraja
     * @return summa
     * @example
     * <pre name="test">
     * valinSumma2($param1) === $tulos
     * $param1 | $tulos
     * -----------------
     *   0     |  0   
     *   1     |  1
     *   2     |  3
     *   3     |  6
     * </pre>
     */
    public static int valinSumma2(int ylaraja) {
        int i, summa;
        for (summa = 0, i = 1; i <= ylaraja; i++)
            summa += i;
        return summa;
    }


    /**
     * Lasketaan yhteen luvut 1..ylaraja
     * @param ylaraja summan ylraja
     * @return summa
     * @example
     * <pre name="test">
     * valinSumma3($param1) === $tulos
     * $param1 | $tulos
     * -----------------
     *   0     |  0   
     *   1     |  1
     *   2     |  3
     *   3     |  6
     * </pre>
     */
    public static int valinSumma3(int ylaraja) {
        int s=0;
        for (int i = ylaraja; i >= 0; s += i--) { /* ei tarvii tehd mitn */ }
        return s;
    }


    /**
     * Testataan vlin summaa
     * @param args ei kytss
     */
    public static void main(String[] args) {
        int summa = valinSumma(0);
        System.out.println("Summa = " + summa);
        summa = valinSumma2(100);
        System.out.println("Summa = " + summa);
        summa = valinSumma3(100);
        System.out.println("Summa = " + summa);
    }
}
