package oliot.aika.rajapinta;

/**
 * Rajapinta Aika-luokille
 * @author  Vesa Lappalainen @version 1.0, 01.02.2003
 * @author Santtu Viitanen @version 1.1, 8.7.2011
 */
public interface AikaRajapinta {



    /**
     * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
     * @param h asetettavat tunnit
     * @param m asetettavat minuutit
     * @return yli- tai alijneet vuorokaudet
     */
    public int aseta(int h, int m);


    /**
     * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
     * @param h asetettavat tunnit
     * @return yli- tai alijneet vuorokaudet
     */
    public int aseta(int h);


    /**
     * Palauttaa ajan merkkijonona muodossa 15:05
     */
    @Override
    public String toString();


    /**
     * Lis aikaan valitun minuuttimrn
     * @param lisa_min listtv minuuttimr
     * @return ylimenneet vuorokaudet
     */
    int lisaa(int lisa_min);


    /**
     * @return ajan tunnit
     */
    int getH();


    /**
     * @return ajan minuutit 
     */
    int getM();
}
