package oliot.sisaluokka;

@SuppressWarnings({"javadoc", "synthetic-access"})
public class KouluLuokka {
    public class Oppilas { // EI staattinen => psee ulkoluokan attribuutteihin
        private final String nimi;  // Oppilas-luokan attribuutti
        private final double keskiarvo;
        
        public Oppilas(String nimi, double keskiarvo) {
            this.nimi = nimi;
            this.keskiarvo = keskiarvo;
        }
        
        public String getLuokkakavereita() {
            return "Mun luokalla " + luokka + " on " + (oppilaita-1) + " kaveria";
        }

        
        @Override
        public String toString() {
            return nimi + " " + keskiarvo;
        }
        
    }
    
    private final String luokka; // KouluLuokka-luokan attribuutteja, joihin
    private int oppilaita;       // oppilas psee ksiksi

    public Oppilas lisaa(String nimi, double ka) {
        Oppilas oppilas = new Oppilas(nimi, ka); // vain ulkoluokka voi luoda olion
        oppilaita++;
        return oppilas;
    }

    
    public KouluLuokka(String luokka) {
        this.luokka = luokka;
    }
    

    public static void main(String[] args) {
        KouluLuokka eka = new KouluLuokka("1B");
        Oppilas kalle = eka.lisaa("Kalle", 7.1);
        Oppilas maija = eka.lisaa("Maija", 9.2);
        Oppilas tytti = eka.lisaa("Tytti", 9.1);
        System.out.println(kalle + ": " + kalle.getLuokkakavereita());
        System.out.println(maija + ": " + maija.getLuokkakavereita());
        System.out.println(tytti + ": " + tytti.getLuokkakavereita());
    }

}
