package taulukot;
import java.util.Arrays;
/**
 * Esitelln taulukoiden testaamista
 * @author vesal
 * @version 5.3.2015
 */
public class Testaaminen {

    /**
     * Alustetaan taulukko juoksevasti
     * @param t alustettava taulukko, taulukon sislt muuttuu
     * @param alku ensimmisen alkion arvo
     * @param askel ero seuraavaan alkioon
     * @return viite alustettuun taulukkoon
     * @example
     * <pre name="test">
     * #import java.util.Arrays;
     *    int[] t = new int[5];
     *    Arrays.toString(t) === "[0, 0, 0, 0, 0]";
     *    alusta(t,3,5);
     *    Arrays.toString(t) === "[3, 8, 13, 18, 23]";
     *    Arrays.toString(alusta(new int[0],1,1)) === "[]";
     *    Arrays.toString(alusta(new int[1],1,1)) === "[1]";
     *    Arrays.toString(alusta(new int[3],1,-1)) === "[1, 0, -1]";
     *    Arrays.toString(alusta(new int[]{1,2},3,2)) === "[3, 5]";
     * </pre>
     */
    public static int[] alusta(int t[], int alku, int askel) {
        int arvo = alku;
        for (int i=0; i<t.length; i++, arvo += askel ) t[i] = arvo;
        return t;
    }
    
    /**
     * Alustetaan taulukko juoksevasti
     * @param t alustettava taulukko, taulukon sislt muuttuu
     * @param alku ensimmisen alkion arvo
     * @param askel ero seuraavaan alkioon
     * @return viite alustettuun taulukkoon
     * @example
     * <pre name="test">
     * #import java.util.Arrays;
     *    Arrays.toString(alusta2(new int[$koko],$alku,$askel)) === "$tulos";
     *    
     *        $koko | $alku | $askel | $tulos
     *     ----------------------------------------------------
     *         5    |  3    |   5    | [3, 8, 13, 18, 23]         
     *         0    |  1    |   1    | []         
     *         1    |  1    |   1    | [1]         
     *         3    |  1    |  -1    | [1, 0, -1]         
     * </pre>
     */
    public static int[] alusta2(int t[], int alku, int askel) {
        int arvo = alku;
        for (int i=0; i<t.length; i++, arvo += askel ) t[i] = arvo;
        return t;
    }
    
    /**
     * @param args ei kytss
     */
    public static void main(String[] args) {
        int[] t = new int[6]; 
        alusta(t,1,2);
        System.out.println(Arrays.toString(t));
        alusta2(t,1,2);
        System.out.println(Arrays.toString(t));
    }
}