package tietokannat;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/**
 * Esimerkki miten luodaan uusi tietokanta
 * @author vesal
 * @version 4.4.2015
 */
public class Kannanluonti {

    /**
     * Luodaan uusi esimerkkikanta.  Poistataan ensin mahdollinen vanha kanta
     * @param args ei kytss
     */
    public static void main(String[] args) {
        String tiedNimi = "kerhomalli.db";
        File ftied = new File(tiedNimi);
        ftied.delete();
        
        String luontilauseke = 
                "CREATE TABLE Jasenet (\n" +                               
                "  jasenID INTEGER PRIMARY KEY AUTOINCREMENT,\n"+
                "  nimi VARCHAR(100) NOT NULL,\n"+
                "  hetu VARCHAR(11) DEFAULT '',\n"+
                "  katuosoite  VARCHAR(100) NOT NULL\n"+
                ")";
        
        try ( Connection con = DriverManager.getConnection("jdbc:sqlite:" + tiedNimi);
              PreparedStatement sql = con.prepareStatement(luontilauseke) ) {
            sql.executeUpdate();
            System.out.println("Luotiin tietokanta: " + tiedNimi);
        } catch (SQLException e) {
            System.err.println("Virhe: " + e.getMessage());
        }
    }
}
