package tietokannat;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/**
 * Esimerkki miten kantaan listn tietueita
 * @author vesal
 * @version 4.4.2015
 */
public class TietueidenLisays {

    /**
     * Listn tietoja tietokantaan
     * @param args ei kytss
     */
    public static void main(String[] args) {
        String tiedNimi = "kerhomalli.db";
        String[][] jasenet = {
            {"Ankka Aku","010245-123U","Ankkakuja"},
            {"Susi Sepe","020347-123T","Susihaara 7"},
            {"Ponteva Veli","030455-3333","Possuntaival 2"}
        };
        int n = 0;
        
        try ( Connection con = DriverManager.getConnection("jdbc:sqlite:" + tiedNimi);
              PreparedStatement sql = con.prepareStatement(
                        "INSERT INTO Jasenet (nimi, hetu, katuosoite) VALUES (?, ?, ?)") ) {
            for ( String[] jasen : jasenet ) {
                sql.setString(1, jasen[0]);  // korvataan vastaavat kysymysmerkit
                sql.setString(2, jasen[1]);
                sql.setString(3, jasen[2]);
                n += sql.executeUpdate();
            }
            System.out.println("Listtyjen rivien mr " + n);
        } catch (SQLException e) {
            System.err.println("Virhe: " + e.getMessage());
        }
    }
}
